module Walid
  module Parser
    class Domain < Parslet::Parser
      rule(:domain) { (label | domain) >> str('.') >> label }
      rule(:label) do
        match('[[:alpha:]]') >> (ldh_str.maybe >> let_dig).maybe
      end
      rule(:let_dig) { match('[[:alnum:]]') }

      root(:domain)
    end
  end
end
